export interface IComment {
    id: string;
    annotationId: string;
    createdBy: string;
    createdByDetails: IdamDetails;
    createdDate: any;
    lastModifiedBy: string;
    lastModifiedByDetails: IdamDetails;
    lastModifiedDate: any;
    content: string;
}
export declare class Comment implements IComment {
    id: string;
    annotationId: string;
    createdBy: string;
    createdByDetails: IdamDetails;
    createdDate: any;
    lastModifiedBy: string;
    lastModifiedByDetails: IdamDetails;
    lastModifiedDate: any;
    content: string;
    constructor(id: string, annotationId: string, createdBy: string, createdByDetails: IdamDetails, createdDate: any, lastModifiedBy: string, lastModifiedByDetails: IdamDetails, lastModifiedDate: any, content: string);
}
export interface IRectangle {
    id?: string;
    annotationId?: string;
    createdBy?: string;
    createdByDetails?: IdamDetails;
    createdDate?: any;
    lastModifiedBy?: string;
    lastModifiedByDetails?: IdamDetails;
    lastModifiedDate?: any;
    height?: number;
    width?: number;
    x?: number;
    y?: number;
}
export declare class Rectangle implements IRectangle {
    id: string;
    annotationId: string;
    createdBy: string;
    createdByDetails: IdamDetails;
    createdDate: any;
    lastModifiedBy: string;
    lastModifiedByDetails: IdamDetails;
    lastModifiedDate: any;
    height: number;
    width: number;
    x: number;
    y: number;
    constructor(id?: string, annotationId?: string, createdBy?: string, createdByDetails?: IdamDetails, createdDate?: any, lastModifiedBy?: string, lastModifiedByDetails?: IdamDetails, lastModifiedDate?: any, height?: number, width?: number, x?: number, y?: number);
}
export interface IAnnotation {
    id?: string;
    annotationSetId?: string;
    createdBy?: string;
    createdByDetails?: IdamDetails;
    createdDate?: any;
    lastModifiedBy?: string;
    lastModifiedByDetails?: IdamDetails;
    lastModifiedDate?: any;
    documentId?: string;
    page?: number;
    color?: string;
    comments?: Comment[];
    rectangles?: Rectangle[];
    type?: string;
}
export declare class Annotation implements IAnnotation {
    id: string;
    annotationSetId: string;
    createdBy: string;
    createdDate: any;
    createdByDetails: IdamDetails;
    lastModifiedBy: string;
    lastModifiedByDetails: IdamDetails;
    lastModifiedDate: any;
    documentId: string;
    page: number;
    color: string;
    comments: Comment[];
    rectangles: Rectangle[];
    type: string;
    constructor(id?: string, annotationSetId?: string, createdBy?: string, createdDate?: any, createdByDetails?: IdamDetails, lastModifiedBy?: string, lastModifiedByDetails?: IdamDetails, lastModifiedDate?: any, documentId?: string, page?: number, color?: string, comments?: Comment[], rectangles?: Rectangle[], type?: string);
}
export declare class IdamDetails {
    forename: string;
    surname: string;
    email: string;
    constructor(forename: string, surname: string, email: string);
}
export interface IAnnotationSet {
    id: string;
    createdBy: string;
    createdByDetails: IdamDetails;
    createdDate: any;
    lastModifiedBy: string;
    lastModifiedByDetails: IdamDetails;
    lastModifiedDate: any;
    documentId: string;
    annotations: Annotation[];
}
export declare class AnnotationSet implements IAnnotationSet {
    id: string;
    createdBy: string;
    createdByDetails: IdamDetails;
    createdDate: any;
    lastModifiedBy: string;
    lastModifiedByDetails: IdamDetails;
    lastModifiedDate: any;
    documentId: string;
    annotations: Annotation[];
    constructor(id: string, createdBy: string, createdByDetails: IdamDetails, createdDate: any, lastModifiedBy: string, lastModifiedByDetails: IdamDetails, lastModifiedDate: any, documentId: string, annotations: Annotation[]);
}
