import { OnInit, ElementRef, ChangeDetectorRef, Renderer2, OnDestroy, AfterViewInit, ComponentRef } from '@angular/core';
import { PdfService } from '../../data/pdf.service';
import { AnnotationStoreService } from '../../data/annotation-store.service';
import { IAnnotationSet, Annotation } from '../../data/annotation-set.model';
import { NpaService } from '../../data/npa.service';
import { ApiHttpService } from '../../data/api-http.service';
import { Utils } from '../../data/utils';
import { PdfAnnotateWrapper } from '../../data/js-wrapper/pdf-annotate-wrapper';
import { CommentsComponent } from './comments/comments.component';
import { ContextualToolbarComponent } from './contextual-toolbar/contextual-toolbar.component';
import { EmLoggerService } from '../../logging/em-logger.service';
import { PdfRenderService } from '../../data/pdf-render.service';
import { RotationFactoryService } from './rotation-toolbar/rotation-factory.service';
import { RotationComponent } from './rotation-toolbar/rotation.component';
export declare class AnnotationPdfViewerComponent implements OnInit, AfterViewInit, OnDestroy {
    private pdfService;
    private npaService;
    private apiHttpService;
    private annotationStoreService;
    private utils;
    private ref;
    private renderer;
    private pdfAnnotateWrapper;
    private pdfRenderService;
    private rotationFactoryService;
    private log;
    annotate: boolean;
    dmDocumentId: string;
    outputDmDocumentId: string;
    url: string;
    annotationSet: IAnnotationSet;
    baseUrl: string;
    private page;
    private focusedAnnotationSubscription;
    private pageNumberSubscription;
    private pdfPageSubscription;
    rotationComponents: ComponentRef<RotationComponent>[];
    contentWrapper: ElementRef;
    viewerElementRef: ElementRef;
    annotationWrapper: ElementRef;
    commentsComponent: CommentsComponent;
    contextualToolbar: ContextualToolbarComponent;
    constructor(pdfService: PdfService, npaService: NpaService, apiHttpService: ApiHttpService, annotationStoreService: AnnotationStoreService, utils: Utils, ref: ChangeDetectorRef, renderer: Renderer2, pdfAnnotateWrapper: PdfAnnotateWrapper, pdfRenderService: PdfRenderService, rotationFactoryService: RotationFactoryService, log: EmLoggerService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    loadAnnotations(annotate: boolean): void;
    handleClick(event: any, isPage?: boolean): void;
    unfocusAnnotation(): void;
    handleAnnotationClick(event: any): void;
    focusHighlightStyle(focusedAnnotation: Annotation): void;
}
